!-----------------------------------------------
! stockage des résultats (format visit)
!-----------------------------------------------


module mod_sorties

  implicit none

  contains
  
    subroutine sortie_visit(numero,f,P,s)

      !------------------------------------------------------
      !      sorties au format vtk (ascii)
      !      lisible par visit 
      !------------------------------------------------------

      !-------------------- modules -------------------------!
      use mod_precision
      use mod_vitesse
      !------------------------------------------------------!

      implicit none

      !---------------------- in ----------------------------!
      character(len=100), intent(in) :: numero
      real(pr), dimension(:), intent(in) :: f
      real(pr), dimension(:,:), intent(in) :: P
      integer, dimension(:,:), intent(in) :: s
      !------------------------------------------------------!

      !--------------- variables locales --------------------!
      integer :: i,nb_noeuds,nb_trig
      character(len=100) :: fich
      !------------------------------------------------------!


      fich='SORTIES/resultats.'//trim(adjustl(numero))//'.vtk'
      open(unit=1,file=fich)

      nb_trig=size(f)
      nb_noeuds=size(p,1)


      write(1,'(1A26)') '# vtk DataFile Version 2.0'
      write(1,*) 'convection 2D'
      write(1,*) 'ASCII'
      write(1,*) 'DATASET UNSTRUCTURED_GRID'

      write(1,*) 'POINTS',nb_noeuds,' double'
      do i=1,nb_noeuds
         write(1,*) p(i,1),p(i,2),0.0_pr
      end do

      write(1,*) 'CELLS ',nb_trig,nb_trig*4
      do i=1,nb_trig
         write(1,*) 3,s(i,1)-1, s(i,2)-1, s(i,3)-1
      end do

      write(1,*) 'CELL_TYPES ',nb_trig
      do i=1,nb_trig
         write(1,*) 5
      end do

      write(1,*) 'CELL_DATA',nb_trig
      write(1,*) 'SCALARS f double'
      write(1,*) 'LOOKUP_TABLE default'
      do i=1,nb_trig
         write(1,*) f(i)
      end do

      close(1)

    end subroutine sortie_visit

  end module mod_sorties
